// Libraries
#include "RTClib.h"
#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <NTPClient.h>
#include <WiFiUdp.h>
#include <EEPROM.h>
#include <ESP8266WebServer.h>
#include <ESP8266mDNS.h>
#include "lwip/netif.h"
#include "netif/etharp.h"

void forceARP() {
netif *n = netif_list;
while(n) {
  etharp_gratuitous(n);
  n=n->next;
}
}

//------------------------------------------------------------------------------------------------------------------------------------------------
RTC_DS3231 rtc;
const long utcOffsetInSeconds = 7200;
ESP8266WebServer server(80);
WiFiUDP ntpUDP;
NTPClient timeClient(ntpUDP, "0.cz.pool.ntp.org", utcOffsetInSeconds);
DateTime now;
long letni,zimni;
char rezim[32],stav[32],stav1,rezim1,zap1,zap2,vyp1,vyp2;
char vypv[32],zapv[32];
char dtmcas[32],cas[32];
signed char hh,mm,ss;
int casi,izap,ivyp;
String req;
unsigned long timeout,timeout1;
char temp[5000];
String header = "HTTP/1.1 301 OK\r\nLocation: /\r\nCache-Control: no-cache\r\n\r\n";
//------------------------------------------------------------------------------------------------------------------------------------------------
const char *ssid     = "SSID";
const char *password = "HESLO";

const char* www_username = "USER";
const char* www_password = "PASSWORD";
//------------------------------------------------------------------------------------------------------------------------------------------------
void setutc() {

  for(int i=25;i<=31;i++)
    {
    DateTime dt1 (now.year(), 10, i, 3, 0, 0);
    if(dt1.dayOfTheWeek()==0) zimni=dt1.unixtime();
    }
  for(int i=25;i<=31;i++)
    {
    DateTime dt2 (now.year(), 3, i, 3, 0, 0);
    if(dt2.dayOfTheWeek()==0) letni=dt2.unixtime();
    }
}
void sync() 
{
  if(WiFi.status() == WL_CONNECTED && timeClient.update()) {
  now=timeClient.getFormattedTime().toInt();
  
  //DateTime now(2019,10,24,3,0,0);
  setutc();
    
  if(now.unixtime()>=letni && now.unixtime()<zimni) {now=timeClient.getFormattedTime().toInt();}else {now=timeClient.getFormattedTime().toInt()-3600;}
  rtc.adjust(DateTime(now.year(), now.month(), now.day(), now.hour(), now.minute(), now.second()));
  }
}
//------------------------------------------------------------------------------------------------------------------------------------------------
void WIFI_Connect()
{


  if(WiFi.status()!=WL_CONNECTED)
  {
  WiFi.disconnect(); 
  WiFi.softAPdisconnect(true);
  WiFi.persistent(true);
  WiFi.setSleepMode(WIFI_NONE_SLEEP);
  
        WiFi.begin(ssid, password);
        for(int i=0;i<25;i++)
          if(WiFi.status()!=WL_CONNECTED)
            {
            //Serial.print(".");
            digitalWrite(D5,HIGH);
            delay(250);
            digitalWrite(D5,LOW);
            delay(250);  
            }
          else {
            digitalWrite(D5,HIGH);
            server.on("/", [](){
              if(server.authenticate(www_username, www_password)) {hlavni();}else {server.requestAuthentication();}  
            });
            server.onNotFound (handleNotFound);
            server.begin();
          }  
  }
  else {

            digitalWrite(D5,HIGH);
            server.on("/", [](){
              if(server.authenticate(www_username, www_password)) {hlavni();}else {server.requestAuthentication();}  
            });
            server.onNotFound (handleNotFound);
            server.begin();
  
  }  
}

void handleNotFound() {server.sendContent(header);}

void hlavni () {

if(server.arg("zapnout")!="") {
  strcpy(rezim,"Ovládání");
  strcpy(stav,"Zapnuto");
  EEPROM.put(0x04, 'o');
  EEPROM.put(0x05, 'z');
  EEPROM.commit();  
}

if(server.arg("vypnout")!="") {
  strcpy(rezim,"Ovládání");
  strcpy(stav,"Vypnuto");
  EEPROM.put(0x04, 'o');
  EEPROM.put(0x05, 'v');
  EEPROM.commit();
}

if(server.arg("runtimer")!="") {  
  strcpy(rezim,"Časování");
 
  req=server.arg("zapv");
  req.toCharArray(zapv,32);
  zap1=req.substring(0,2).toInt();
  zap2=req.substring(3,5).toInt();

  req=server.arg("vypv");
  req.toCharArray(vypv,32);
  vyp1=req.substring(0,2).toInt();
  vyp2=req.substring(3,5).toInt();
  izap=zap1*60+zap2;
  ivyp=vyp1*60+vyp2;

  EEPROM.put(0x00, zap1);
  EEPROM.put(0x01, zap2);   
  EEPROM.put(0x02, vyp1);
  EEPROM.put(0x03, vyp2); 
  EEPROM.put(0x04, 'c');
  EEPROM.commit();
}

if(server.arg("ntp")!="") {
  sync();
}
  if(strcmp(rezim, "Časování")==0)
  {
  if(izap<ivyp) {if((casi>=izap) && (casi<ivyp)) {strcpy(stav,"Zapnuto");} else {strcpy(stav,"Vypnuto");}}
  if(izap>ivyp) {if((casi>=izap) || (casi<ivyp)) {strcpy(stav,"Zapnuto");} else {strcpy(stav,"Vypnuto");}}
  if(izap==ivyp) {strcpy(stav,"Vypnuto");}
  }
sprintf(dtmcas,"%02d. %02d %4d</br>%02d:%02d:%02d",now.day(),now.month(),now.year(),now.hour(),now.minute(),now.second());
  
snprintf_P(temp,5000, PSTR("<html>\
<head>\
<meta http-equiv='Content-Language' content='cs'>\
<meta http-equiv='Content-Type' content='text/html; charset=UTF-8'>\
<title>Arduino Wifi zásuvka</title>\
</head>\
<body link='#000000' vlink='#000000' alink='#000000' bgcolor='#333333' style='margin: 50px 0px 0px 0px;'>\
<div align='center'>\
  <a href='javascript:window.location.assign(\"http://\" + window.location.hostname);'><b><font size='7' face='Arial' color='#FFFFFF'>Arduino Wifi zásuvka</font></b></a>\
  <table border='1' width='80%' cellspacing='0' cellpadding='0' bordercolor='#000000'>\
    <tr>\
      <td align='center' width='40%' height='40' bgcolor='#C0C0C0'>Stav</td>\
      <td align='center' width='40%' height='40' bgcolor='#C0C0C0'>%s</td></tr>\
    <tr>\
      <td align='center' width='40%' height='40' bgcolor='#C0C0C0'>Režim</td>\
      <td align='center' width='40%' height='40' bgcolor='#C0C0C0'>%s</td>\
    </tr>\
    <tr>\
      <td align='center' width='80%' colspan='2' bgcolor='#808080' height='40'><font size='5'>Ovládání</font></td>\
    </tr>\
    <form action='' method='get'>\
    <tr>\
      <td align='center' width='40%' bgcolor='#808080' height='150'><input type='submit' value='Zapnout' name='zapnout' style='width:80%;height:80%;font-size: 36pt;'></td>\
      <td align='center' width='40%' bgcolor='#808080' height='150'><input type='submit' value='Vypnout' name='vypnout' style='width:80%;height:80%;font-size: 36pt;'></td>\
    </tr>\
    </form>\
    <tr>\
      <td align='center' width='80%' colspan='2' bgcolor='#C0C0C0' height='40'><font size='5'>Časování</font></td>\
    </tr>\
    <form action='' method='get'>\
    <tr>\
      <td align='center' width='40%' bgcolor='#C0C0C0' height='40'>Zapnout v</td>\
      <td align='center' width='40%' bgcolor='#C0C0C0' height='150'><input type='time' name='zapv' value='%s' style='color: #000000; border: 1px solid #000000;width:80%;height:80%;font-size: 36pt;text-align:center;'></td>\
    </tr>\
    <tr>\
      <td align='center' width='40%' bgcolor='#C0C0C0' height='40'>Vypnout v</td>\
      <td align='center' width='40%' bgcolor='#C0C0C0' height='150'><input type='time' name='vypv' value='%s' style='color: #000000; border: 1px solid #000000;width:80%;height:80%;font-size: 36pt;text-align:center;'></td>\
    </tr>\                                                                                                   
    <tr>\
      <td align='center' width='80%' height='150' colspan='2' bgcolor='#C0C0C0'><input type='submit' value='Spustit časovač' name='runtimer' style='width:80%;height:80%;font-size: 36pt;'></td>\
    </tr>\
    </form>\
    <form action='' method='get'>\
    <tr>\
      <td align='center' width='40%' height='40' bgcolor='#808080'>Net time protocol</td>\
      <td align='center' width='40%' height='40' bgcolor='#808080'><input type='submit' value='Synchronizovat s NTP serverem' name='ntp'></td>\
    </tr>\
    <tr>\
      <td align='center' width='40%' height='40' bgcolor='#C0C0C0'>Čas</td>\
      <td align='center' width='40%' height='40' bgcolor='#C0C0C0'><font size='2'>%s</font></td>\
    </tr>\
    </form>\
    </table>\
</div>\
</body>\
</html>"),(char*)stav,(char*)rezim,(char*)zapv,(char*)vypv,(char*)dtmcas);

server.send ( 200, "text/html", temp);
}
//------------------------------------------------------------------------------------------------------------------------------------------------
void setup() {
  //Serial.begin(9600);delay(1000);
  pinMode(2,OUTPUT);
  digitalWrite(2,HIGH);
  pinMode(16,OUTPUT);
  digitalWrite(16,HIGH);
  pinMode(D5,OUTPUT);
  digitalWrite(D5,LOW);
  pinMode(D6,OUTPUT);
  digitalWrite(D6,LOW);
  

  EEPROM.begin(512);
  EEPROM.get(0x00,zap1);
  EEPROM.get(0x01,zap2);
  EEPROM.get(0x02,vyp1);
  EEPROM.get(0x03,vyp2);
  EEPROM.get(0x04,rezim1);
  EEPROM.get(0x05,stav1);
  EEPROM.commit();
  
  if(zap1==255) zap1=0;
  if(zap2==255) zap2=0;
  if(vyp1==255) vyp1=0;
  if(vyp2==255) vyp2=0;
  if(rezim1==255) strcpy(rezim,"Ovládání"); 
  if(stav1==255) strcpy(stav,"Vypnuto");  
  
  if(rezim1=='c') strcpy(rezim,"Časování");
  if(rezim1=='o') strcpy(rezim,"Ovládání");

  sprintf(zapv,"%02d:%02d",zap1,zap2);
  sprintf(vypv,"%02d:%02d",vyp1,vyp2);
  
  if(stav1=='z') strcpy(stav,"Zapnuto");
  if(stav1=='v') strcpy(stav,"Vypnuto"); 

  IPAddress ip(192, 168, 100, 203);
  IPAddress gateway(192, 168, 100, 1);
  IPAddress subnet(255, 255, 255, 0);
  WiFi.config(ip, gateway, subnet);
  rtc.begin();
  timeout=millis();
  timeout1=millis();
}
//------------------------------------------------------------------------------------------------------------------------------------------------
void loop() {

  if(millis()>=timeout) {timeout=millis()+60000;WIFI_Connect();}
  if(millis()>=timeout1) {timeout1=millis()+1000;if(WiFi.status()==WL_CONNECTED) forceARP();}
  
  now = rtc.now();

  hh = now.hour();
  mm = now.minute();
  ss = now.second();

  casi=hh*60+mm;
  izap=zap1*60+zap2;
  ivyp=vyp1*60+vyp2;

  if(strcmp(rezim, "Časování")==0)
  {
    if(izap<ivyp) {if((casi>=izap) && (casi<ivyp)) {digitalWrite(2,LOW);digitalWrite(16,LOW);digitalWrite(D6,HIGH);} else {digitalWrite(2,HIGH);digitalWrite(16,HIGH);digitalWrite(D6,LOW);}}
    if(izap>ivyp) {if((casi>=izap) || (casi<ivyp)) {digitalWrite(2,LOW);digitalWrite(16,LOW);digitalWrite(D6,HIGH);} else {digitalWrite(2,HIGH);digitalWrite(16,HIGH);digitalWrite(D6,LOW);}}
    if(izap==ivyp) {digitalWrite(2,HIGH);digitalWrite(16,HIGH);strcpy(stav,"Vypnuto");digitalWrite(D6,LOW);}
  }
  
  if((strcmp(rezim, "Ovládání")==0) && (strcmp(stav, "Zapnuto")==0)) {digitalWrite(2,LOW);digitalWrite(16,LOW);digitalWrite(D6,HIGH);}
  
  if((strcmp(rezim, "Ovládání")==0) && (strcmp(stav, "Vypnuto")==0)) {digitalWrite(2,HIGH);digitalWrite(16,HIGH);digitalWrite(D6,LOW);} 
 
  server.handleClient();
  delay(10);
}
